QCAT - User Story #1781

Versioning of configuration
06 Feb 2018 14:22 - Sebastian Manger

Status: Closed Start date: 06 Feb 2018
Priority: Normal Due date:

Assignee: % Done: 100%
Category: Estimated time: 0.00 hour
Target version: Carbon Benefit Spent time: 111.00 hours
Resolution:

Description

Intro

The 'initial' version of all configurations is hard coded (JSON). This has historic reasons, the initial plan for QCAT was to have many
small, modular questionnaires that can be linked. As a configuration now is a very large (> 20k lines) file, this should not be copied
and only the changes ('diff') are stored for a new version.

Naming

® Years are used to identify a version, e.g. technology 2018. If multiple versions are released per year, the month is appended
(2018.6)

Technical details

Before estimate: proof of concept.
A configuration is a json object, which is loaded into the database.
A new version of the configuration contains only the 'difference' as code

e Similar to a django migration.
¢ Rationale: when storing code, help texts and such can easily be added. Also, the indicators for 'this question has changed'
can be calculated.

To be defined: even if the new version is saved as 'diff', when applying it (probably as management command) - is it expanded
to the full json in the database?

Subtasks:

Task # 1782: Proof of concept: new configuration as code Closed
Task # 1783: Configuration: database layout changes Closed
Task # 1784: Caching: aware of version Closed
History

#1 - 06 Feb 2018 14:27 - Sebastian Manger

- Subject changed from New configuration: to New configuration: Add changes

#2 - 08 Feb 2018 11:04 - Lukas Vonlanthen

- Subject changed from New configuration: Add changes to Versioning of configuration

#3 - 27 Feb 2018 09:55 - Kurt Gerber

- Status changed from New to Accepted

#4 - 05 Apr 2018 09:43 - Kurt Gerber

- Status changed from Accepted to In Progress

#5 - 04 Jul 2018 10:03 - Lukas Vonlanthen

- Status changed from In Progress to Closed
